/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Tue Nov  1 00:08:09 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000045F (1119)
 *     Revision         0x01
 *     Checksum         0x81
 *     OEM ID           "ACRSYS"
 *     OEM Table ID     "ACRPRDCT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "1025"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "ACRSYS", "ACRPRDCT", 0x00001000)
{
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.LPCB.EC0_.BRTS, IntObj)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (PCIS, PCI_Config, Zero, 0x04)
        Field (PCIS, ByteAcc, NoLock, Preserve)
        {
            DVID,   16
        }

        Method (_DOD, 0, NotSerialized)
        {
            Name (DTMX, Package (0x03)
            {
                0x0110, 
                0x80000100, 
                0x80007330
            })
            Return (DTMX)
        }

        Method (_DOS, 1, NotSerialized)
        {
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (0x0110)
            }

            Method (_DCS, 0, NotSerialized)
            {
                Return (0x1F)
            }

            Method (_DGS, 0, NotSerialized)
            {
                Return (One)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }

            Method (_BCL, 0, Serialized)
            {
                Return (Package (0x0C)
                {
                    0x64, 
                    0x32, 
                    0x0A, 
                    0x14, 
                    0x1E, 
                    0x28, 
                    0x32, 
                    0x3C, 
                    0x46, 
                    0x50, 
                    0x5A, 
                    0x64
                })
            }

            Method (_BQC, 0, NotSerialized)
            {
                Store (\_SB.PCI0.LPCB.EC0.BRTS, Local0)
                Increment (Local0)
                Multiply (Local0, 0x0A, Local0)
                Return (Local0)
            }

            Method (_BCM, 1, Serialized)
            {
                If (LAnd (LGreaterEqual (Arg0, 0x0A), LLessEqual (Arg0, 0x64)))
                {
                    Divide (Arg0, 0x0A, Local0, Arg0)
                    Decrement (Arg0)
                    Sleep (0x64)
                    Store (Arg0, \_SB.PCI0.LPCB.EC0.BRTS)
                }
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (0x80000100)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }

            Method (_DCS, 0, NotSerialized)
            {
                Return (0x1F)
            }

            Method (_DGS, 0, NotSerialized)
            {
                Return (One)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (0x80007330)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }

            Method (_DCS, 0, NotSerialized)
            {
                Return (0x1F)
            }

            Method (_DGS, 0, NotSerialized)
            {
                Return (One)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Name (DSWR, Zero)
        Name (NXTD, Zero)
        Name (INDX, Zero)
        Name (SACC, Buffer (0x03)
        {
            0x01, 0x02, 0x03
        })
        Name (SACH, Buffer (0x03)
        {
            0x01, 0x08, 0x09
        })
        Name (SACT, Buffer (0x05)
        {
            0x01, 0x02, 0x08, 0x03, 0x09
        })
        Method (ATIF, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP0, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP0, Zero, F0SS)
                CreateWordField (TMP0, 0x02, F0IV)
                CreateDWordField (TMP0, 0x04, F0SN)
                CreateDWordField (TMP0, 0x08, F0SF)
                Store (0x0C, F0SS)
                Store (One, F0IV)
                Store (0x51, F0SN)
                Store (0x07, F0SF)
                Return (TMP0)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F1SS)
                CreateDWordField (TMP1, 0x02, F1VF)
                CreateDWordField (TMP1, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x03, F1VF)
                Store (One, F1FG)
                Return (TMP1)
            }

            If (LEqual (Arg0, 0x02))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F2SS)
                CreateDWordField (TMP2, 0x02, F2PR)
                CreateByteField (TMP2, 0x06, F2EM)
                CreateByteField (TMP2, 0x07, F2TG)
                CreateByteField (TMP2, 0x08, F2SI)
                CreateByteField (TMP2, 0x09, F2FG)
                CreateByteField (TMP2, 0x0A, F2FI)
                CreateByteField (TMP2, 0x0B, F2SP)
                Store (0x0A, F2SS)
                Name (STS2, Zero)
                Or (DSWR, STS2, STS2)
                Store (STS2, F2PR)
                Store (Zero, DSWR)
                Return (TMP2)
            }

            If (LEqual (Arg0, 0x03))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, F3SS)
                CreateWordField (TMP3, 0x02, F3SD)
                CreateWordField (Arg1, Zero, AI3S)
                CreateWordField (Arg1, 0x02, SLDS)
                CreateWordField (Arg1, 0x04, CODS)
                Store (SLDS, Local1)
                And (Local1, 0x0B, Local1)
                Store (CODS, Local2)
                Or (Local2, One, Local2)
                Store (Zero, Local0)
                Store (0x03, INDX)
                If (LEqual (CODS, 0x0B))
                {
                    Store (0x05, INDX)
                }

                While (LLess (Local0, INDX))
                {
                    If (LEqual (Local2, 0x03))
                    {
                        Store (DerefOf (Index (SACC, Local0)), Local3)
                    }
                    Else
                    {
                        If (LEqual (Local2, 0x09))
                        {
                            Store (DerefOf (Index (SACH, Local0)), Local3)
                        }
                        Else
                        {
                            Store (DerefOf (Index (SACT, Local0)), Local3)
                        }
                    }

                    If (LEqual (Local3, Local1))
                    {
                        Increment (Local0)
                        If (LEqual (Local0, INDX))
                        {
                            Store (Zero, Local0)
                        }

                        Store (Local0, NXTD)
                        Store (INDX, Local0)
                    }
                    Else
                    {
                        Increment (Local0)
                    }
                }

                If (LEqual (NXTD, INDX))
                {
                    Store (Zero, SLDS)
                }
                Else
                {
                    Store (NXTD, Local0)
                    If (LEqual (Local2, 0x03))
                    {
                        Store (DerefOf (Index (SACC, Local0)), Local3)
                    }
                    Else
                    {
                        If (LEqual (Local2, 0x09))
                        {
                            Store (DerefOf (Index (SACH, Local0)), Local3)
                        }
                        Else
                        {
                            Store (DerefOf (Index (SACT, Local0)), Local3)
                        }
                    }

                    Store (Local3, SLDS)
                }

                Store (0x04, F3SS)
                Store (SLDS, F3SD)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (AFN0, 0, Serialized)
        {
            Store (One, DSWR)
            Notify (\_SB.PCI0.PEG0.PEGP, 0x81)
        }
    }
}

